'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof2 = require('babel-runtime/helpers/typeof');

var _typeof3 = _interopRequireDefault(_typeof2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.default = composeReducers;

var _lodash = require('lodash.reduce');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.every');

var _lodash4 = _interopRequireDefault(_lodash3);

var _lodash5 = require('lodash.foreach');

var _lodash6 = _interopRequireDefault(_lodash5);

var _lodash7 = require('lodash.mapvalues');

var _lodash8 = _interopRequireDefault(_lodash7);

var _createReducer = require('./createReducer');

var _createReducer2 = _interopRequireDefault(_createReducer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function composeReducers() {
  for (var _len = arguments.length, reducers = Array(_len), _key = 0; _key < _len; _key++) {
    reducers[_key] = arguments[_key];
  }

  if (reducers.length === 0) return function (state) {
    return state;
  };
  if (reducers.length === 1) return reducers[0];

  // if all reducers have actionHandlers maps, merge the maps using composeReducers
  if ((0, _lodash4.default)(reducers, function (reducer) {
    return reducer.actionHandlers instanceof Object;
  })) {
    var _ret = function () {
      var actionHandlers = {};
      var initialState = void 0;
      reducers.forEach(function (reducer) {
        if (initialState === undefined) initialState = reducer.initialState;
        (0, _lodash6.default)(reducer.actionHandlers, function (actionHandler, type) {
          (actionHandlers[type] || (actionHandlers[type] = [])).push(actionHandler);
        });
      });
      return {
        v: (0, _createReducer2.default)(initialState, (0, _lodash8.default)(actionHandlers, function (typeHandlers) {
          return composeReducers.apply(undefined, (0, _toConsumableArray3.default)(typeHandlers));
        }))
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
  }

  return function (state, action) {
    return (0, _lodash2.default)(reducers, function (state, reducer) {
      return reducer(state, action);
    }, state);
  };
}