'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;

var _lodash = require('lodash.mapvalues');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createMiddleware(actionHandlers) {
  var result = function result(store) {
    var handlersForStore = (0, _lodash2.default)(actionHandlers, function (handler) {
      return handler(store);
    });
    return function (next) {
      var handlersForNext = (0, _lodash2.default)(handlersForStore, function (handler) {
        return handler(next);
      });
      return function (action) {
        var handler = handlersForNext[action.type];
        return handler ? handler(action) : next(action);
      };
    };
  };
  result.actionHandlers = actionHandlers;
  return result;
}